program plot_err

  use sep

  implicit none

  integer :: j, i, l, f_weight, v_weight
  real :: f_fun, v_mean, v_stdd, v(101), f(101), dv, df, err(101,101), ds, a(4), k, temp, pe(101,101), pf(101), pv(101)
  real, parameter :: pi = 3.14159265359

  call sep_init()

  call from_param("f_fun", f_fun, 40.)
  call from_param("v_mean", v_mean, 2000.)
  call from_param("v_stdd", v_stdd, 200.)
  call from_param("ds", ds, 5.)
  call from_param("a", a)
  call from_param("f_weight",f_weight,0)
  call from_param("v_weight",v_weight,0)

  df = 2.5*f_fun/100.
  f = (/ ((i-1)*df, i=1,101) /)
  if (f_weight == 0) then
    pf = 1.
  elseif (f_weight == 1) then
    pf = (/ (2/sqrt(pi)*f(i)**2/f_fun**3*exp(-f(i)**2/f_fun**2), i=1,101) /)
  elseif (f_weight == 2) then
    pf = (/ (2/sqrt(pi)*f(i)**2/f_fun**3*exp(-f(i)**2/f_fun**2), i=1,101) /)
    pf = 1. + maxval(pf) - pf
  else
    pf = f
  endif
    
  dv = 6*v_stdd/100.
  v = (/ (v_mean-3*v_stdd+(j-1)*dv, j=1,101) /)
  if (v_weight == 0) then
    pv = 1.
  elseif (v_weight == 1) then
    pv = (/ (exp(-(v(j)-v_mean)**2/2/v_stdd**2)/sqrt(2*pi*v_stdd**2), j=1,101) /)
  elseif (v_weight == 2) then
    pv = (/ (exp(-(v(j)-v_mean)**2/2/v_stdd**2)/sqrt(2*pi*v_stdd**2), j=1,101) /)
    pv = 1. + maxval(pv) - pv
  else
    pv = 1./v/v
  endif
  
  do j=1,101
    do i=1,101
      k = 2.0*pi*f(i)/v(j)
      temp = a(1)*(cos(1.*k*ds)-1.) + a(2)*(cos(2.*k*ds)-1.) +&
             a(3)*(cos(3.*k*ds)-1.) + a(4)*(cos(4.*k*ds)-1.)
      err(i,j) = 2.*temp + ds*ds*k*k
      pe(i,j) = pf(i)*pv(j)
    enddo
  enddo

  pe = pe/sum(pe)

  call to_history("n1",101)
  call to_history("n2",101)
  call to_history("d1",df)
  call to_history("d2",dv)
  call to_history("o1",0)
  call to_history("o2",v_mean-3*v_stdd)

  call to_history("n1",101,"weight")
  call to_history("n2",101,"weight")
  call to_history("d1",df,"weight")
  call to_history("d2",dv,"weight")
  call to_history("o1",0,"weight")
  call to_history("o2",v_mean-3*v_stdd,"weight")
  write(0,*) maxval(abs(err))
  call sep_write(err)
  call sep_write(pe,"weight")

  call sep_close()

end program
