program sa

  use sep
  use sa_mod

  implicit none

  integer :: f_weight, v_weight, error, norm
  character*80 :: ofile
  real :: ds, f_fun, v_mean, v_stdd, t, max_e, p_fit, f_max, v, a(4), a_new(4)
  double precision :: eo, en, r, tt

  call sep_init()

  call from_param("max_e",max_e,0.01)
  call from_param("ds", ds, 5.)
  call from_param("f_fun", f_fun, 40.)
  call from_param("f_max", f_max, 100.)
  call from_param("v", v, 1800.)
  call from_param("p_fit", p_fit, 100.)
  call from_param("v_mean", v_mean, 2500.)
  call from_param("v_stdd", v_stdd, 300.)
  call from_param("t", t, 1000.)

  call from_param("ofile",ofile,"result.txt")
  call from_param("f_weight",f_weight,0)
  call from_param("v_weight",v_weight,0)
  call from_param("norm",norm,0)
  call from_param("error",error,0)

  tt = t
  call init_paperc8()
  a = c8(1:4)

if (error == 1) then
 call init_sa_fv(p_fit,ds,f_fun,v_mean,v_stdd,f_weight,v_weight)
 if (norm == 2) then
  eo = L2_err(a)  
  do while (eo > max_e)
    call neighbor(a,a_new)
    en = L2_err(a_new)    
    call random_number(r)
    if (p(eo,en,tt) >= r) then
      a = a_new
      eo = en
    endif
    write(0,*) eo, en
    write(0,*) a
    write(0,*) a_new
    tt = tt*0.99    
  enddo
  open(2,file=ofile,form="formatted")
  write(2,*) p(eo,en,tt), eo, en
  write(2,*) tt
  write(2,*) L2_err(a), L2_err(a_new)
  write(2,*) a_new
  write(2,*) a
  close(2)

 else
  eo = max_err(a)  
  do while (eo > max_e)
    call neighbor(a,a_new)
    en = max_err(a_new)    
    call random_number(r)
    if (p(eo,en,tt) >= r) then
      a = a_new
      eo = en
    endif
    write(0,*) eo, en
    write(0,*) a
    write(0,*) a_new
    tt = tt*0.99    
  enddo
  open(2,file=ofile,form="formatted")
  write(2,*) p(eo,en,tt), eo, en
  write(2,*) tt
  write(2,*) max_err(a), max_err(a_new)
  write(2,*) a_new
  write(2,*) a
  close(2)
 endif

else
 call init_sa_k(p_fit,ds,v,f_max)
  eo = max_rel_err(a)  
  do while (eo > max_e)
    call neighbor(a,a_new)
    en = max_rel_err(a_new)    
    call random_number(r)
    if (p(eo,en,tt) >= r) then
      a = a_new
      eo = en
    endif
    write(0,*) eo, en
    write(0,*) a
    write(0,*) a_new
    tt = tt*0.99    
  enddo
  open(2,file=ofile,form="formatted")
  write(2,*) p(eo,en,tt), eo, en
  write(2,*) tt
  write(2,*) max_rel_err(a), max_rel_err(a_new)
  write(2,*) a_new
  write(2,*) a
  close(2)
endif

end program

