program test

  use sep

  implicit none

  integer :: i
  real :: dsd, a(4,6), oper_err(101,6), phase_err(101,6), group_err(101,6), v(6)
  double precision :: k(101), G(101), dGdk(101), ds
  real, parameter :: pi = 3.14159265359

  call sep_init()

  call from_param("a1", a(:,1))
  call from_param("a2", a(:,2))
  call from_param("a3", a(:,3))
  call from_param("a4", a(:,4))
  call from_param("a5", a(:,5))
  call from_param("a6", a(:,6))

  call from_param("ds", dsd)
  ds = dsd
  k = (/ (i*pi/ds/100., i=1,101) /)
  v = (/ (1500. + (i-1)*180., i=1,6) /)
write(0,*) v
write(0,*) k
  do i=1,6
    G = (2./ds**2)*(a(1,i)*(cos(1.*k*ds)-1.) + a(2,i)*(cos(2.*k*ds)-1.) +&
                    a(3,i)*(cos(3.*k*ds)-1.) + a(4,i)*(cos(4.*k*ds)-1.))
    dGdk = (-2./ds)*(1.*a(1,i)*sin(1.*k*ds) + 2.*a(2,i)*sin(2.*k*ds) +&
                     3.*a(3,i)*sin(3.*k*ds) + 4.*a(4,i)*sin(4.*k*ds))
    phase_err(:,i) = v(i)*(sqrt(-G)/k - 1.)
    group_err(:,i) = v(i)*((- dGdk)/(2.*sqrt(-G)) - 1.)
    oper_err(:,i) = ds*ds*(G + k*k)
    if (i==6) then
        write(0,*) a(:,i)
	write(0,*) G
    endif
  enddo

  call to_history("n1",101,"phase_err")
  call to_history("n2",6,"phase_err")
  call to_history("d1",pi/dsd/100.,"phase_err")
  call to_history("d2",200,"phase_err")
  call to_history("o1",pi/dsd/100.,"phase_err")
  call to_history("o2",2000.,"phase_err")

  call to_history("n1",101,"group_err")
  call to_history("n2",6,"group_err")
  call to_history("d1",pi/dsd/100.,"group_err")
  call to_history("d2",200,"group_err")
  call to_history("o1",0,"group_err")
  call to_history("o2",2000.,"group_err")

  call to_history("n1",101)
  call to_history("n2",6)
  call to_history("d1",pi/dsd/100.)
  call to_history("d2",200)
  call to_history("o1",0)
  call to_history("o2",2000.)

  call sep_write(oper_err)
  call sep_write(phase_err,"phase_err")
  call sep_write(group_err,"group_err")

  call sep_close()

end program
