 program vel_build

  use sep

  implicit none
  
  real :: v_mean, v_stdd, v(11), dv, pv(11), ds, vv
  real, parameter :: pi = 3.14159265359
  real, allocatable :: vel(:,:)
  integer :: nx, nz, j, thickness(11), depth, v_dis

  call sep_init()

  call from_param("v", vv, 2000.)
  call from_param("v_mean", v_mean, 2000.)
  call from_param("v_stdd", v_stdd, 200.)
  call from_param("ds",ds,5.)
  call from_param("v_dis",v_dis,0)

  if (v_dis /= 0 .and. v_dis /= 1) then
    nz = 752
    nx = 752
    allocate(vel(nz,nx))
    vel = vv
  else
    dv = 6*v_stdd/10.
    v = (/ (v_mean-3*v_stdd+(j-1)*dv, j=1,11) /)
    if (v_dis == 0) then
      thickness = 68
      thickness(1) = 72
    else
      pv = (/ (exp(-(v(j)-v_mean)**2/2/v_stdd**2)/sqrt(2*pi*v_stdd**2), j=1,11) /)
      pv = pv/sum(pv)
      thickness = nint(2*pv/minval(pv))
    endif
    nz = sum(thickness)
    nx = nz
    allocate(vel(nz,nx))
    do j=1,11
      depth = sum(thickness(1:j))
      write(0,*) depth
      vel(depth-thickness(j)+1:depth,:) = v(j)
      depth = depth + thickness(j)
    enddo
  endif

  call to_history("n1",nz)
  call to_history("n2",nx)
  call to_history("d1",ds)
  call to_history("d2",ds)
  call to_history("o1",0.)
  call to_history("o2",0.)
 
  call sep_write(vel)

  call sep_close()

end program
